# Integrations

LlamaIndex has a number of community integrations, from vector stores, to prompt trackers, tracers, and more!

## LlamaPacks -- Code Templates

LlamaHub hosts a full suite of LlamaPacks -- templates for features that you can download, edit, and try out! This offers a quick way to learn about new features and try new techniques.

The full set of LlamaPacks is available on [LlamaHub](https://llamahub.ai/). Check out our dedicated page below.

```{toctree}
---
maxdepth: 1
---
llama_packs/root.md
```

## Data Loaders

The full set of data loaders are found on [LlamaHub](https://llamahub.ai/)

## Agent Tools

The full set of agent tools are found on [LlamaHub](https://llamahub.ai/)

## LLMs

We support [a huge number of LLMs](/module_guides/models/llms/modules.md).

## Observability/Tracing/Evaluation

Check out our [one-click observability](/module_guides/observability/observability.md) page
for full tracing integrations.

```{toctree}
---
maxdepth: 1
---
/module_guides/observability/observability.md
integrations/uptrain.md
integrations/deepeval.md
integrations/graphsignal.md
integrations/trulens.md

```

## Structured Outputs

```{toctree}
---
maxdepth: 1
---
integrations/guidance.md
integrations/lmformatenforcer.md
Guardrails </examples/output_parsing/GuardrailsDemo.ipynb>
OpenAI Function Calling </examples/output_parsing/openai_pydantic_program.ipynb>
```

## Storage and Managed Indexes

```{toctree}
---
maxdepth: 1
---
integrations/vector_stores.md
integrations/graph_stores.md
integrations/managed_indices.md
```

## Application Frameworks

```{toctree}
---
maxdepth: 1
---
integrations/using_with_langchain.md
Streamlit <https://blog.streamlit.io/build-a-chatbot-with-custom-data-sources-powered-by-llamaindex/>
Chainlit <https://docs.chainlit.io/integrations/llama-index>
```

## Distributed Compute

```{toctree}
---
maxdepth: 1
---
LlamaIndex + Ray <https://www.anyscale.com/blog/build-and-scale-a-powerful-query-engine-with-llamaindex-ray>

```

## Other

```{toctree}
---
maxdepth: 1
---
integrations/chatgpt_plugins.md
Poe <https://github.com/poe-platform/poe-protocol/tree/main/llama_poe>
Airbyte <https://airbyte.com/tutorials/airbyte-and-llamaindex-elt-and-chat-with-your-data-warehouse-without-writing-sql>
integrations/fleet_libraries_context.md

```
