# Discover LlamaIndex Video Series

If you like learning from videos, now's a good time to check out our "Discover LlamaIndex" series. If not, we recommend heading on to our [Understanding LlamaIndex](/understanding/understanding.md) tutorial.

## Bottoms-Up Development (Llama Docs Bot)

This is a sub-series within Discover LlamaIndex that shows you how to build a document chatbot from scratch.

We show you how to do this in a "bottoms-up" fashion - start by using the LLMs, and data objects as independent modules. Then gradually add higher-level abstractions like indexing, and advanced retrievers/rerankers.

[Full Repo](https://github.com/run-llama/llama_docs_bot)
[[Part 1] LLMs and Prompts](https://www.youtube.com/watch?v=p0jcvGiBKSA)
[[Part 2] Documents and Metadata](https://www.youtube.com/watch?v=nGNoacku0YY)
[[Part 3] Evaluation](https://www.youtube.com/watch?v=LQy8iHOJE2A)
[[Part 4] Embeddings](https://www.youtube.com/watch?v=2c64G-iDJKQ)
[[Part 5] Retrievers and Postprocessors](https://www.youtube.com/watch?v=mIyZ_9gqakE)

## SubQuestionQueryEngine + 10K Analysis

This video covers the `SubQuestionQueryEngine` and how it can be applied to financial documents to help decompose complex queries into multiple sub-questions.

[Youtube](https://www.youtube.com/watch?v=GT_Lsj3xj1o)

[Notebook](../../examples/usecases/10k_sub_question.ipynb)

## Discord Document Management

This video covers managing documents from a source that is constantly updating (i.e. Discord) and how you can avoid document duplication and save embedding tokens.

[Youtube](https://www.youtube.com/watch?v=j6dJcODLd_c)

[Notebook and Supplementary Material](https://github.com/jerryjliu/llama_index/tree/main/docs/examples/discover_llamaindex/document_management/)

[Reference Docs](/module_guides/indexing/document_management.md)

## Joint Text to SQL and Semantic Search

This video covers the tools built into LlamaIndex for combining SQL and semantic search into a single unified query interface.

[Youtube](https://www.youtube.com/watch?v=ZIvcVJGtCrY)

[Notebook](../../examples/query_engine/SQLAutoVectorQueryEngine.ipynb)
