# Module Guides

These guide provide an overview of how to use our agent classes.

For more detailed guides on how to use specific tools, check out our [tools module guides](tools/root.md).

## OpenAI Agent

```{toctree}
---
maxdepth: 1
---
/examples/agent/openai_agent.ipynb
/examples/agent/openai_agent_with_query_engine.ipynb
/examples/agent/openai_agent_retrieval.ipynb
/examples/agent/openai_agent_query_cookbook.ipynb
/examples/agent/openai_agent_query_plan.ipynb
/examples/agent/openai_agent_context_retrieval.ipynb
/examples/query_engine/recursive_retriever_agents.ipynb
/examples/agent/multi_document_agents.ipynb
/examples/agent/agent_builder.ipynb
/examples/agent/openai_agent_parallel_function_calling.ipynb
```

## [Beta] OpenAI Assistant Agent

```{toctree}
---
maxdepth: 1
---
/examples/agent/openai_assistant_agent.ipynb
/examples/agent/openai_retrieval_benchmark.ipynb
/examples/agent/openai_assistant_query_cookbook.ipynb
```

## ReAct Agent

```{toctree}
---
maxdepth: 1
---
/examples/agent/react_agent.ipynb
/examples/agent/react_agent_with_query_engine.ipynb
```

## Additional Agents (available on LlamaHub)

```{toctree}
---
maxdepth: 1
---
LLMCompiler Agent Cookbook <https://github.com/run-llama/llama-hub/blob/main/llama_hub/llama_packs/agents/llm_compiler/llm_compiler.ipynb>
```

(lower-level-agent-api)=

## Custom Agents

```{toctree}
---
maxdepth: 1
---
/examples/agent/custom_agent.ipynb
/examples/agent/agent_runner/query_pipeline_agent.ipynb
```

## Lower-Level Agent API

```{toctree}
---
maxdepth: 1
---
/examples/agent/agent_runner/agent_runner.ipynb
/examples/agent/agent_runner/agent_runner_rag.ipynb
/examples/agent/agent_runner/agent_runner_rag_controllable.ipynb
```
