# Full-Stack Web Application

LlamaIndex can be integrated into a downstream full-stack web application. It can be used in a backend server (such as Flask), packaged into a Docker container, and/or directly used in a framework such as Streamlit.

We provide tutorials and resources to help you get started in this area:

- [Fullstack Application Guide](/understanding/putting_it_all_together/apps/fullstack_app_guide.md) shows you how to build an app with LlamaIndex as an API and a TypeScript+React frontend
- [Fullstack Application with Delphic](/understanding/putting_it_all_together/apps/fullstack_with_delphic.md) walks you through using LlamaIndex with a production-ready web app starter template called Delphic.
- The [LlamaIndex Starter Pack](https://github.com/logan-markewich/llama_index_starter_pack) provides very basic flask, streamlit, and docker examples for LlamaIndex.

```{toctree}
---
maxdepth: 1
hidden: true
---
/understanding/putting_it_all_together/apps/fullstack_app_guide.md
/understanding/putting_it_all_together/apps/fullstack_with_delphic.md
```
